namedRegExp = require('named-regexp').named

class RegExpResolver extends Object
  constructor:()->
    @patternCache = {}

  isMatch:(pattern,value)->
    return @regExpForPattern(pattern).test(value)

  matchesForPattern:(pattern,value)->
    match = @regExpForPattern(pattern).exec(value)
    captures = {}
    for key,_ of match.captures
      captures[key] = match.capture(key)
    return captures

  regExpForPattern:(pattern)->
    re = @patternCache[pattern]
    if not re
      re = namedRegExp(new RegExp(pattern.replace(/\*/,'.*').replace(/(:([a-zA-Z][a-zA-Z0-9_]*))/g,'(:<$2>[^/]+)')))
      @patternCache[pattern] = re
    return re

  attributesInPattern:(pattern)->
    re = /:([a-zA-Z][a-zA-Z0-9_]*)/g
    attrs = []
    while match = re.exec(pattern)
      attrs.push(match[1])
    return attrs;


module.exports = RegExpResolver